;
        title   Screen Capture, 1.0.0
; ___________________________________________________
;|                                                   |
;| GeneSys Screen Capture, 1.0.0    P. Gene Brennick |
;| pbrennick@verizon.net    http://www.pbrennick.com |
;|___________________________________________________|
;|                                                   |
;| Version key is as follows:                        |
;|           GeneSys Screen Capture a.b.c            |
;|           a:  a major change to the GUI           |
;|           b:  functions added and/or changed      |
;|           c:  bug fixes                           |
;|                                                   |
;| Version History:                                  |
;| September 23, 2003 Reworked and cleaned up the    |
;|                    code to make it more readable. |
;|                                                   |
;| February 12, 2002  Major rewrite and first        |
;|                    release of the software        |
;|                    Version tracking starts        |
;|                    from this point, on.           |
;|                                                   |
;| This Program will capture the screen and save it  |
;| to a bitmap file.                                 |
;|                                                   |
;| A window containing a pushbutton with a VERY tiny |
;| footprint is created on the screen.  When the     |
;| button is clicked, the window will close BEFORE   |
;| the capture takes place so it does not show up in |
;| the captured picture.  There is a one second      |
;| delay between the closing of the capture window   |
;| and the capture, itself, so as to make sure that  |
;| it is closed.  It has been tested on Win98/XP.    |
;|                                     Editor's Note |
;|___________________________________________________|
;|                                                   |
        .386      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|
;
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc
;
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
;
CapScreen   PROTO   :DWORD
MainProc    PROTO   :DWORD, :DWORD, :DWORD, :DWORD
WaitOne     PROTO
;
MOVmw   MACRO   Var1, Var2
        pushad
        lea     esi, Var2
        lea     edi, Var1
          REPEAT  2
          mov     al, [esi]
          mov     [edi], al
          inc     esi
          inc     edi
          ENDM
        popad
        ENDM
;
.data
;--------------------------------------
DlgMain     db  'MAIN', 0
hInstance   dd  0
szDisplay   db  "DISPLAY", 0
szNoDC      db  "Couldn''t create device context.", 0
szNoMemDC   db  "Couldn''t create compatible device context.", 0
szNoBMP     db  "Couldn''t create compatible bitmap.", 0
szNoObj     db  "Couldn''t select bitmap.", 0
szNoCopy    db  "Couldn''t copy bitmap.", 0
szNoFile    db  "Couldn''t write file to disk.", 0
szDone      db  "Bitmap captured to disk file.", 0
bmpfile     db  "screen.bmp", 0
Second      dd  0
Waiting     db  0
;
.const
;--------------------------------------
IDC_CAPTURE   equ 3000
;
sTime       SYSTEMTIME  <?>            ; For Current Date and Time
;
;
.code
;--------------------------------------;
Start:  invoke  GetModuleHandle, NULL  ; Get our app Handle from Windows
        mov     hInstance, eax         ; Store it for later use
        invoke  DialogBoxParam, hInstance, ADDR DlgMain, 0, ADDR MainProc, 0
        invoke  ExitProcess, eax       ; Close program and release resources
;
;
MainProc    PROC    hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;--------------------------------------;
        .if uMsg == WM_CLOSE           ; If Close button clicked ...
          invoke  EndDialog, hWin, 0   ; Close the Window [Dialog Box]
          push    1                    ; Set Errorlevel
          pop     eax                  ; Errorlevel==1
          ret                          ; Return
        .endif                         ;
        .if uMsg == WM_COMMAND         ;
          .if wParam == IDC_CAPTURE    ; If Capture button clicked ...
            invoke  EndDialog, hWin, 0 ; Close the Window [Dialog Box]
            invoke  WaitOne            ; A one second delay
            invoke CapScreen, OFFSET bmpfile    ; Capture the screen
            xor     eax, eax           ; Errorlevel==0
            ret                        ; Return
          .endif                       ;
        .endif                         ;
        xor     eax, eax               ; Errorlevel==0
        ret                            ; Return
;--------------------------------------;
MainProc    endp
;
;
CapScreen       proc lpFileName:DWORD
;--------------------------------------
        LOCAL   hdc:HDC
        LOCAL   memdc:HDC
        LOCAL   hFile:HANDLE
        LOCAL   dwBytes:DWORD
        LOCAL   bitmapfileheader:BITMAPFILEHEADER
        LOCAL   bitmapinfoheader:BITMAPINFOHEADER
        LOCAL   colors[256]:RGBQUAD
        LOCAL   bmpinfo:BITMAPINFO
        LOCAL   hBitmap:HBITMAP
        LOCAL   pBits:DWORD
        LOCAL   dwWidth:DWORD
        LOCAL   dwHeight:DWORD
        LOCAL   dwNumColors:DWORD
        LOCAL   dwBPP:DWORD
        LOCAL   ColorSize:DWORD
;
        invoke  CreateDC, addr szDisplay, NULL, NULL, NULL
        mov     hdc, eax
        .if (eax==NULL)
          invoke  MessageBox, 0, addr szNoDC, NULL, 0
          ret
        .endif
        invoke  GetDeviceCaps, hdc, HORZRES
        mov     dwWidth, eax
        invoke  GetDeviceCaps, hdc, VERTRES
        mov     dwHeight, eax
        invoke  GetDeviceCaps, hdc, BITSPIXEL
        mov     dwBPP, eax
        .if (eax<=8)
          invoke  GetDeviceCaps, hdc, NUMCOLORS
          mov     dwNumColors, eax
          mov     dwNumColors, 256      ; This one looks bad
        .else
          mov     dwNumColors, 0
        .endif
        invoke  CreateCompatibleDC, hdc
        mov     memdc, eax
        .if (eax==NULL)
          invoke  DeleteDC, hdc
          invoke  MessageBox, 0, addr szNoMemDC, NULL, 0
          ret
        .endif
        mov     bmpinfo.bmiHeader.biSize, sizeof BITMAPINFOHEADER
        mov     eax, dwWidth
        mov     bmpinfo.bmiHeader.biWidth, eax
        mov     eax, dwHeight
        mov     bmpinfo.bmiHeader.biHeight, eax
        mov     bmpinfo.bmiHeader.biPlanes, 1
        mov     ax, word ptr [dwBPP]
        mov     bmpinfo.bmiHeader.biBitCount, ax
        mov     bmpinfo.bmiHeader.biCompression, BI_RGB
        mov     bmpinfo.bmiHeader.biSizeImage, 0
        mov     bmpinfo.bmiHeader.biXPelsPerMeter, 0
        mov     bmpinfo.bmiHeader.biYPelsPerMeter, 0
        mov     eax, dwNumColors
        mov     bmpinfo.bmiHeader.biClrUsed, eax
        mov     bmpinfo.bmiHeader.biClrImportant, eax
        invoke  CreateDIBSection, hdc, addr bmpinfo, DIB_PAL_COLORS, addr pBits, NULL, 0
        mov     hBitmap, eax
        .if (eax==NULL)
          invoke  DeleteDC, hdc
          invoke  DeleteDC, memdc
          invoke  MessageBox, 0, addr szNoBMP, NULL, 0
          ret
        .endif
        invoke  SelectObject, memdc, hBitmap
        .if (eax==NULL) || (eax==GDI_ERROR)
          invoke  DeleteDC, hdc
          invoke  DeleteDC, memdc
          invoke  MessageBox, 0, addr szNoObj, NULL, 0
          ret
        .endif
        invoke  BitBlt, memdc, 0, 0, dwWidth, dwHeight, hdc, 0, 0, SRCCOPY
        .if (!eax)
          invoke  DeleteDC, hdc
          invoke  DeleteDC, memdc
          invoke  MessageBox, 0, addr szNoCopy, NULL, 0
          ret
        .endif
        mov     eax, dwNumColors
        .if (eax!=0)
          invoke  GetDIBColorTable, memdc, 0, dwNumColors, addr colors
          mov     dwNumColors, eax
        .endif
        mov     bitmapfileheader.bfType, 4D42h
        mov     eax, dwNumColors
        xor     edx, edx
        mov     ecx, sizeof RGBQUAD
        mul     ecx
        mov     ColorSize, eax
        mov     eax, dwWidth
        xor     edx, edx
        mov     ecx, dwHeight
        mul     ecx
        xor     edx, edx
        mov     ecx, dwBPP
        mul     ecx
        shr     eax, 3
        add     eax, ColorSize
        add     eax, sizeof BITMAPFILEHEADER
        add     eax, sizeof BITMAPINFOHEADER
        mov     bitmapfileheader.bfSize, eax
        mov     bitmapfileheader.bfReserved1, 0
        mov     bitmapfileheader.bfReserved2, 0
        mov     eax, ColorSize
        add     eax, sizeof BITMAPFILEHEADER
        add     eax, sizeof BITMAPINFOHEADER
        mov     bitmapfileheader.bfOffBits, eax
        mov     bitmapinfoheader.biSize, sizeof BITMAPINFOHEADER
        mov     eax, dwWidth
        mov     bitmapinfoheader.biWidth, eax
        mov     eax, dwHeight
        mov     bitmapinfoheader.biHeight, eax
        mov     bitmapinfoheader.biPlanes, 1
        mov     ax, word ptr [dwBPP]
        mov     bitmapinfoheader.biBitCount, ax
        mov     bitmapinfoheader.biCompression, BI_RGB
        mov     bitmapinfoheader.biSizeImage, 0
        mov     bitmapinfoheader.biXPelsPerMeter, 0
        mov     bitmapinfoheader.biYPelsPerMeter, 0
        mov     eax, dwNumColors
        mov     bitmapinfoheader.biClrUsed, eax
        mov     bitmapinfoheader.biClrImportant, 0
        invoke  CreateFile, lpFileName, GENERIC_WRITE, 0,\
                NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
        mov     hFile, eax
        .if (eax==INVALID_HANDLE_VALUE)
          invoke  DeleteObject, hBitmap
          invoke  DeleteDC, memdc
          invoke  DeleteDC, hdc
          invoke  MessageBox, 0, addr szNoFile, NULL, 0
          ret
        .endif
        invoke  WriteFile, hFile, addr bitmapfileheader, sizeof BITMAPFILEHEADER, addr dwBytes, NULL
        invoke  WriteFile, hFile, addr bitmapinfoheader, sizeof BITMAPINFOHEADER, addr dwBytes, NULL
        mov     eax, dwNumColors
        .if (eax != 0)
          invoke  WriteFile, hFile, addr colors, ColorSize, addr dwBytes, NULL
        .endif
        mov     eax, dwWidth
        xor     edx, edx
        mov     ecx, dwHeight
        mul     ecx
        xor     edx, edx
        mov     ecx, dwBPP
        mul     ecx
        shr     eax, 3
        mov     ColorSize, eax
        invoke  WriteFile, hFile, pBits, ColorSize, addr dwBytes, NULL
        invoke  CloseHandle, hFile
        invoke  MessageBox, 0, addr szDone, NULL, 0
        invoke  DeleteObject, hBitmap
        invoke  DeleteDC, memdc
        invoke  DeleteDC, hdc
        ret
;--------------------------------------
CapScreen   endp
;
;
; ______________________________________
;|                                      |
;| Create a one-second delay timer.     |
;|______________________________________|
;
WaitOne proc
;--------------------------------------;
delay:  push    offset sTime           ; Get the local
        call    GetLocalTime           ; time from Windows
        .if Waiting == 0               ; Initial run?
          MOVmw   Second, sTime.wSecond
          inc     Waiting              ; Sync the counter
        .endif                         ;
        push    Second                 ; Put current second on the stack
        pop     eax                    ; Get current second
        add     eax, 1                 ; Get delay value [one second]
        cmp     ax, sTime.wSecond      ; Has it changed?
        ja      delay                  ; Show message for 1 second
        ret                            ; Bye
;--------------------------------------;
WaitOne endp
;
;
        end     Start

